<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title> camv-rnd user manual </title>
<meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
<link rel="stylesheet" type="text/css" href=" ../default.css">
</head>
<body>
<p>
<h1> camv-rnd User Manual: Appendix </h1>
<p>
<h2> Action Reference</h2>
<table border=1>
<caption>
 <b>
, 
</b>
<th> Action <th> Description <th> Syntax <th> Plugin
<tr><td>About</td><td>Present the about box</td><td>About()</td><td>camv_dialogs</td>
<tr><td>ActionString</td><td>Execute a pcb-rnd action parsing a string; syntac: "action(arg,arg,arg)"</td><td>ActionString(action)</td><td>script plugin</td>
<tr><td><a href="action_details.html#addtimer">AddTimer</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Add a new timer</td><td>AddTimer(action, period, [repeat], [userdata])</td><td>script plugin</td>
<tr><td><a href="action_details.html#anyload">AnyLoad</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Load "anything" from path (or offer a file selectio dialog if no path specified)</td><td>AnyLoad([path])</td><td></td>
<tr><td>awk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>bas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td><a href="action_details.html#benchmark">Benchmark</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Benchmark the GUI speed.</td><td>Benchmark()</td><td></td>
<tr><td>BrowseScripts</td><td>Present a dialog box for browsing scripts</td><td>BrowseScripts()</td><td>script plugin</td>
<tr><td><a href="action_details.html#center">Center</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Moves the pointer to the center of the window.</td><td>Center()</td><td>lib_hid_common plugin</td>
<tr><td>ChkGridSize</td><td>Return 1 if the currently selected grid matches the expected_size. If argument is "none" return 1 if there is no grid.</td><td>ChkGridSize(expected_size)<br>ChkGridSize(none)</td><td></td>
<tr><td>ChkGridUnits</td><td>Return 1 if currently selected grid unit matches the expected (normally mm or mil)</td><td>ChkGridUnits(expected)</td><td></td>
<tr><td>ChkMode</td><td>Return 1 if the currently selected mode is the expected_mode</td><td>ChkMode(expected_mode)</td><td></td>
<tr><td>cli_MessageBox</td><td>Intenal: CLI frontend action. Do not use directly.</td><td></td><td></td>
<tr><td>cli_PromptFor</td><td>Intenal: CLI frontend action. Do not use directly.</td><td></td><td></td>
<tr><td>ColorLayer</td><td>Change the color of a layer addressed (@ for current). Not affected by ResetLayer(). Colorstr shall be #rrggbb with hex components.</td><td>ColorLayer(@|last|idx, colorstr)</td><td></td>
<tr><td>Command</td><td>Displays the command line input in the status area.</td><td>Command()</td><td>lib_hid_common plugin</td>
<tr><td>conf</td><td>Perform various operations on the configuration tree.</td><td>conf(set, path, value, [role], [policy]) - change a config setting to an absolute value<br>conf(delta, path, value, [role], [policy]) - change a config setting by a delta value (numerics-only)<br>conf(toggle, path, [role]) - invert boolean value of a flag; if no role given, overwrite the highest prio config<br>conf(reset, role) - reset the in-memory lihata of a role<br>conf(iseq, path, value) - returns whether the value of a conf item matches value (for menu checked's)</td><td></td>
<tr><td>confget</td><td>Return conf node value or property from the merged in-memory/native storage. Returns nil if node is unset (for value query) or not found. Intended for scripting.</td><td>ConfGet(path, [value]) - return the value of a conf node; units, colors and lists are returned as string.<br>ConfGet(path, desc) - return the human readable description<br>ConfGet(path, ArraySize) - number of elements<br>ConfGet(path, ReadOnly) - returns 1 if node is read-only, 0 otherwise<br>ConfGet(path, ConfRev) - conf (merge) rev number the value last changed</td><td></td>
<tr><td>CreateMenu</td><td>Creates a new menu, popup (only path specified) or submenu (at least path and action are specified)</td><td>CreateMenu(path)<br>CreateMenu(path, action, tooltip, cookie, [accel])</td><td></td>
<tr><td><a href="action_details.html#cursor">Cursor</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Move the cursor.</td><td>Cursor(Type,DeltaUp,DeltaRight,Units)</td><td></td>
<tr><td>dad</td><td>Manipulate Dynamic Attribute Dialogs</td><td>dad(dlgname, new) - create new dialog<br>dad(dlgname, label, text) - append a label widget<br>dad(dlgname, button, text) - append a button widget<br>dad(dlgname, button_closes, label, retval, ...) - standard close buttons<br>dad(dlgname, enum, choices) - append an enum (combo box) widget; choices is a tab separated list<br>dad(dlgname, bool) - append an checkbox widget (default off)<br>dad(dlgname, integer|real|coord, min, max) - append an input field<br>dad(dlgname, string) - append a single line text input field<br>dad(dlgname, default, val) - set the default value of a widet while creating the dialog<br>dad(dlgname, help, tooltip) - set the help (tooltip) text for the current widget<br>dad(dlgname, progress) - append a progress bar (set to 0)<br>dad(dlgname, preview, cb_act_prefix, minsize_x, minsize_y, [ctx]) - append a preview with a viewbox of 10*10mm, minsize in pixels<br>dad(dlgname, tree, cols, istree, [header]) - append tree-table widget; header is like enum values<br>dad(dlgname, tree_append, row, cells) - append after row (0 means last item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, tree_append_under, row, cells) - append at the end of the list under row (0 means last item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, tree_insert, row, cells) - insert before row (0 means first item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, begin_hbox) - begin horizontal box<br>dad(dlgname, begin_vbox) - begin vertical box<br>dad(dlgname, begin_hpane) - begin horizontal paned box<br>dad(dlgname, begin_vpane) - begin vertical paned box<br>dad(dlgname, begin_table, cols) - begin table layout box<br>dad(dlgname, begin_tabbed, tabnames) - begin a view with tabs; tabnames are like choices in an enum; must have as many children widgets as many names it has<br>dad(dlgname, end) - end the last begin<br>dad(dlgname, flags, flg1, flg2, ...) - change the flags of the last created widget<br>dad(dlgname, onchange, action) - set the action to be called on widget change<br>dad(dlgname, run, title) - present dlgname as a non-modal dialog<br>dad(dlgname, run_modal, title) - present dlgname as a modal dialog<br>dad(dlgname, exists) - returns wheter the named dialog exists (0 or 1)<br>dad(dlgname, set, widgetID, val) - changes the value of a widget in a running dialog <br>dad(dlgname, get, widgetID, [unit]) - return the current value of a widget<br>dad(dlgname, iterate) - runs a global GUI iteration (event dispatch, redraw)<br>dad(dlgname, raise) - pops up window in front<br>dad(dlgname, close) - close the dialog (and return 0 from modal run)</td><td>lib_hid_common plugin</td>
<tr><td>dlg_confval_edit</td><td>Present a dialog box for editing the value of a conf node at path.</td><td>dlg_confval_edit(path, idx, role, [modal])</td><td>lib_hid_common plugin</td>
<tr><td>duktape</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>DumpActions</td><td>Dump all actions available.</td><td>DumpActions()</td><td></td>
<tr><td>dumpconf</td><td>Perform various operations on the configuration tree.</td><td>dumpconf(native, [verbose], [prefix]) - dump the native (binary) config tree to stdout<br>dumpconf(lihata, role, [prefix]) - dump in-memory lihata representation of a config tree</td><td>diag_rnd</td>
<tr><td>DumpPluginDirs</td><td>Print plugins directories in a format digestable by scripts.</td><td>DumpPluginDirs()</td><td></td>
<tr><td>DumpPlugins</td><td>Print plugins loaded in a format digestable by scripts.</td><td>DumpPlugins()</td><td></td>
<tr><td>DumpVersion</td><td>Dump version in script readable format.</td><td>DumpVersion()</td><td></td>
<tr><td>estutter</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>EvalConf</td><td>Perform various operations on the configuration tree.</td><td>EvalConf(path) - evaluate a config path in different config sources to figure how it ended up in the native database</td><td>diag_rnd</td>
<tr><td>ExecActionFile</td><td>Run actions from the given file.</td><td>ExecuteFile(filename)</td><td></td>
<tr><td>ExecuteFile</td><td>Run actions from the given file.</td><td>ExecuteFile(filename)</td><td></td>
<tr><td>ExportDialog</td><td>Open the export dialog.</td><td>ExportDialog()</td><td>lib_hid_common plugin</td>
<tr><td>fawk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>fbas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>fpas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>FsdSimple</td><td>File selection dialog, simplified API; for meaning of the arguments, see the HID API doc.</td><td>FsdSimple(title, descr, default_file, default_ext, history_tag, [read])</td><td>lib_hid_common plugin</td>
<tr><td>FsdTest</td><td>Central, DAD based File Selection Dialog demo</td><td>FsdTest()</td><td>lib_hid_common plugin</td>
<tr><td>FullScreen</td><td>Hide widgets to get edit area full screen</td><td>FullScreen(on|off|toggle)</td><td></td>
<tr><td><a href="action_details.html#getxy">GetXY</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Get a coordinate. If x or y specified, the return value of the action is the x or y coordinate.</td><td>GetXY([message, [x|y]])</td><td></td>
<tr><td>Grid</td><td>Set the grid.</td><td>grid(set, [name:]size[@offs][!unit])<br>grid(+|up)<br>grid(-|down)<br>grid(#N)<br>grid(idx, N)<br>grid(get)<br>grid(ask)</td><td></td>
<tr><td>GroupLoad</td><td>Starts or ends a group load of files.</td><td>GroupLoad(begin|end)</td><td>plug_io_act</td>
<tr><td>gui_FallbackColorPick</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_MayOverwriteFile</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_MessageBox</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_PromptFor</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>Help</td><td>On-line action help</td><td>Help()</td><td></td>
<tr><td>InvertLayer</td><td>Inverts the layer addressed (@ for current). Not affected by ResetLayer().</td><td>InvertLayer(@|last|idx)</td><td></td>
<tr><td>irc</td><td>non-modal, single-instance, single-server, single-channel irc window for online support</td><td>irc()</td><td>irc plugin</td>
<tr><td>javascript</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>js</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>LayerDialog</td><td>Present the LayerDialog box on the currently selected layer</td><td>LayerDialog()</td><td>camv_dialogs</td>
<tr><td><a href="action_details.html#listscripts">ListScripts</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>List fungw scripts, optionally filtered wiht regex pat.</td><td>ListScripts([pat])</td><td>script plugin</td>
<tr><td><a href="action_details.html#livescript">LiveScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Manage a live script</td><td>LiveScript([new], [name])<br>LiveScript(load|save, name, [filame])<br>LiveScript(run|stop|rerun|undo, name)</td><td>script plugin</td>
<tr><td>LoadFrom</td><td>Load project or layer data from a file.</td><td>LoadFrom(Layer|Project,filename[,format])</td><td>plug_io_act</td>
<tr><td><a href="action_details.html#loadscript">LoadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Load a fungw script</td><td>LoadScript(id, filename, [language])</td><td>script plugin</td>
<tr><td>Log</td><td>Manages the central, in-memory log.</td><td>Log(clear, [fromID, [toID])<br>Log(export, [filename, [text|lihata])</td><td></td>
<tr><td>LogDialog</td><td>Open the log dialog.</td><td>LogDialog()</td><td>lib_hid_common plugin</td>
<tr><td>LogGui</td><td>Log() action GUI section</td><td>LogGui(export, [filename, [text|lihata])</td><td></td>
<tr><td>lua</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>ManagePlugins</td><td>Manage plugins dialog.</td><td>ManagePlugins()</td><td>lib_hid_common plugin</td>
<tr><td>mawk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>MenuDebug</td><td>Menu debug helpers: save the merged menu in a file</td><td>MenuDebug(save, path)</td><td></td>
<tr><td>MenuPatch</td><td>Manage menu patches</td><td>MenuPatch(load, cookie, path, desc)<br>MenuPatch(unload, cookie)<br>MenuPatch(list)<br>MenuPatch(InhibitInc|InhibitDec)</td><td></td>
<tr><td><a href="action_details.html#message">Message</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Writes a message to the log window.</td><td>message([ERROR|WARNING|INFO|DEBUG,] message)</td><td></td>
<tr><td>MessageBox</td><td>Open a modal message dialog box with title and label. If icon string is not empty, display the named icon on the left. Present one or more window close buttons with different text and return value.</td><td>MessageBox(icon, title, label, button_txt, button_retval, ...)</td><td></td>
<tr><td>Mode</td><td>Change or use the tool mode.</td><td>Tool(Arc|Arrow|Copy|InsertPoint|Line|Lock|Move|None|PasteBuffer)<br>Tool(Poly|Rectangle|Remove|Rotate|Text|Thermal|Via)<br>Tool(Press|Release|Cancel|Stroke)<br>Tool(Save|Restore)</td><td></td>
<tr><td>MoveCursorTo</td><td>Move the cursor to absolute coords, pan the view as needed.</td><td>MoveCursorTo(x,y)</td><td></td>
<tr><td>mruby</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>Oneliner</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td><a href="action_details.html#pan">Pan</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Start or stop panning (Mode = 1 to start, 0 to stop)</td><td>Pan(Mode)</td><td>lib_hid_common plugin</td>
<tr><td>pas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>pcb_acos</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_asin</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_atan2</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_atan</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_cos</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_rand</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_sin</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_sqrt</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_srand</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_tan</td><td></td><td></td><td>script plugin</td>
<tr><td>perl</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>Preferences</td><td>Present the preferences dialog, optionally opening the tab requested.</td><td>Preferences([tabname])</td><td>lib_hid_common plugin</td>
<tr><td><a href="action_details.html#print">Print</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Present the print export dialog for printing the layout from the GUI.</td><td>Print()</td><td></td>
<tr><td>PrintActions</td><td>Print all actions available.</td><td>PrintActions()</td><td></td>
<tr><td>PrintCopyright</td><td>Print copyright notice.</td><td>PrintCopyright()</td><td></td>
<tr><td>PrintDialog</td><td>Open the print dialog.</td><td>PrintDialog()</td><td>lib_hid_common plugin</td>
<tr><td>PrintFiles</td><td>Print files currently loaded.</td><td>PrintFiles()</td><td></td>
<tr><td>PrintPaths</td><td>Print full paths and search paths.</td><td>PrintPaths()</td><td></td>
<tr><td>PrintUsage</td><td>Print command line arguments of camv-rnd or a plugin loaded.</td><td>PrintUsage()<br>PrintUsage(plugin)</td><td></td>
<tr><td>PrintVersion</td><td>Print version.</td><td>PrintVersion()</td><td></td>
<tr><td><a href="action_details.html#promptfor">PromptFor</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Prompt for a string. Returns the string (or NULL on cancel)</td><td>PromptFor([message[,default[,title]]])</td><td></td>
<tr><td>py</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>python</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>Quit</td><td>Quits the application.</td><td>Quit()</td><td></td>
<tr><td>Redraw</td><td>Redraw the entire screen</td><td>Redraw()</td><td></td>
<tr><td><a href="action_details.html#reloadscript">ReloadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Reload a fungw script</td><td>ReloadScript(id)</td><td>script plugin</td>
<tr><td>RemoveMenu</td><td>Recursively removes a new menu, popup (only path specified) or submenu. </td><td>RemoveMenu(path, cookie)</td><td></td>
<tr><td>ResetLayer</td><td>Reset the transformation matrix of the layer.</td><td>ResetLayer(@|last|idx, sx[, sy])</td><td></td>
<tr><td>rnd_acos</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_asin</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_atan2</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_atan</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_cos</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_dlg_xpm_by_name</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_rand</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_sin</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_sqrt</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_srand</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_tan</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_toolbar_init</td><td>For ringdove apps: initialize the toolbar.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_toolbar_uninit</td><td>For ringdove apps: uninitialize the toolbar.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_zoom</td><td>Change zoom level (relative, absolute, window, ...)</td><td>Zoom()<br>Zoom([+|-|=]factor)<br>Zoom(x1, y1, x2, y2)<br>Zoom(?)<br>Zoom(get)</td><td>lib_hid_common plugin</td>
<tr><td>RotateLayer</td><td>Rotates the layer addressed (@ for current) by deg degrees CCW. (The transformation is added to the current transformation matrix of the layer.)</td><td>RotateLayer(@|last|idx, [deg])</td><td></td>
<tr><td>ruby</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>SafeFsclearerr</td><td>Same as clearerr(3)</td><td>SafeFsclearerr(f)</td><td></td>
<tr><td>SafeFsFclose</td><td>Closes a file previously open using SafeFsFopen()</td><td>SafeFsFclose(f)</td><td></td>
<tr><td>SafeFsFeof</td><td>Returns 1 if file has reached EOF, 0 otherwise</td><td>SafeFsFeof(f)</td><td></td>
<tr><td>SafeFsFerror</td><td>Returns 1 if file had errors, 0 otherwise</td><td>SafeFsFerror(f)</td><td></td>
<tr><td>SafeFsFgets</td><td>Reads and returns a line from f (open with SafeFsFopen()). Stops reading after maxlen (subsequent call will continue reading the same line). Returns nil on error or eof or empty line. Maxlen is 64k by default. Note: string heap allocation is made for maxlen.</td><td>SafeFsFgets(f, [maxlen])</td><td></td>
<tr><td>SafeFsFileMtime</td><td>Return the last modification time of a file, from Epoch, or -1 on error.</td><td>SafeFsFileMtime(path)</td><td></td>
<tr><td>SafeFsFileSize</td><td>Return the size of a file in bytes, or -1 on error.</td><td>SafeFsFileSize(path)</td><td></td>
<tr><td>SafeFsFopen</td><td>Opens a file using fopen, returns FILE *. If mode is not specified, r is assumed. Returns nil on error.</td><td>SafeFsFopen(path, [mode])</td><td></td>
<tr><td>SafeFsFputs</td><td>Writes str to file f (previously opne with SafeFsFopen))</td><td>SafeFsFputs(f, str)</td><td></td>
<tr><td>SafeFsFread</td><td>Reads and returns at most len bytes from a file (open with SafeFsFopen()). Returns nil on error or eof or empty line.</td><td>SafeFsFread(f, len)</td><td></td>
<tr><td>SafeFsFreadSep</td><td>Reads characters that are either all non-seps or all seps. Reads at most maxlen bytes. Returns the string read or nil on eof or error. Seps is a string that contains every separator character. Maxlen is 64k by default.</td><td>SafeFsFreadSep(f, seps, [maxlen])</td><td></td>
<tr><td>SafeFsFseek</td><td>Same as fseek(3); whence is a string, one of set, cur or end not specified (set is used when not specified)</td><td>SafeFsFseek(f, offs, [whence])</td><td></td>
<tr><td>SafeFsFtell</td><td>Same as ftell(3).</td><td>SafeFsFtell(f)</td><td></td>
<tr><td>SafeFsIsDir</td><td>Return 1 if path exists and is a directory, else return 0.</td><td>SafeFsIsDir(path)</td><td></td>
<tr><td>SafeFsMkdir</td><td>Mkdir a file from the file system. If mode is a string, it is converted from octal. Return value is the same as mkdir(2)'s</td><td>SafeFsMkdir(path, mode)</td><td></td>
<tr><td>SafeFsPathSep</td><td>Return the system dependet path separator character (normally slash).</td><td>SafeFsPathSep(path)</td><td></td>
<tr><td>SafeFsReadFile</td><td>Reads a text file into one long string, returned, but at most maxlen bytes. If maxlen is not specified, 64k is used. Returns nil on error or empty file.</td><td>SafeFsReadFile(path, [maxlen])</td><td></td>
<tr><td>SafeFsRealPath</td><td>Returns the realpath(3) of path, or NULL on error.</td><td>SafeFsRealPath(path)</td><td></td>
<tr><td>SafeFsRemove</td><td>Remove an object from the file system. Return value is the same as remove(3)'s</td><td>SafeFsRemove(path)</td><td></td>
<tr><td>SafeFsRename</td><td>Rename an object on the file system. Return value is the same as rename(2)'s</td><td>SafeFsRename(old_path, new_path)</td><td></td>
<tr><td>SafeFsRewind</td><td>Same as rewind(3)</td><td>SafeFsRewind(f)</td><td></td>
<tr><td>SafeFsSystem</td><td>Runs cmdline with a shell using librnd safe_fs. Return value is the same integer as system()'s</td><td>SafeFsSystem(cmdline)</td><td></td>
<tr><td>SafeFsUnlink</td><td>Unlink a file from the file system. Return value is the same as unlink(2)'s</td><td>SafeFsUnlink(path)</td><td></td>
<tr><td>SaveTo</td><td>Save design to a file.</td><td>SaveTo(design, filename[,format])</td><td>plug_io_act</td>
<tr><td>ScaleLayer</td><td>Scales the layer addressed (@ for current) by the factor of sx and sy. If only sx is specified, it is used as sy as well. (The transformation is added to the current transformation matrix of the layer.)</td><td>ScaleLayer(@|last|idx, [sx, [sy]])</td><td></td>
<tr><td><a href="action_details.html#scriptcookie">ScriptCookie</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Return a cookie specific to the current script instance during script initialization</td><td>ScriptCookie()</td><td>script plugin</td>
<tr><td><a href="action_details.html#scriptpersistency">ScriptPersistency</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Read or remove script persistency data savd on preunload</td><td>ScriptPersistency(read|remove)</td><td>script plugin</td>
<tr><td><a href="action_details.html#scroll">Scroll</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Scroll the viewport.</td><td>Scroll(up|down|left|right, [pixels])</td><td>lib_hid_common plugin</td>
<tr><td>SetGrid</td><td>Change grid size.</td><td>SetGrid(delta|*mult|/div, [unit])</td><td></td>
<tr><td><a href="action_details.html#setgridoffs">SetGridOffs</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Change grid offset (alignment) to x_offs and y_offs. Offsets should be specified with units.</td><td>SetGridOffs(x_offs, y_offs)</td><td></td>
<tr><td><a href="action_details.html#setunits">SetUnits</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Set the default measurement units.</td><td>SetUnits(mm|mil)</td><td></td>
<tr><td>stroke</td><td>Various gesture recognition related functions</td><td>stroke(gesture, seq)</td><td>stroke plugin</td>
<tr><td>stt</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>System</td><td>Run shell command</td><td>System(shell_cmd)</td><td></td>
<tr><td>tcl</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td><a href="action_details.html#tool">Tool</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Change or use the tool mode.</td><td>Tool(Arc|Arrow|Copy|InsertPoint|Line|Lock|Move|None|PasteBuffer)<br>Tool(Poly|Rectangle|Remove|Rotate|Text|Thermal|Via)<br>Tool(Press|Release|Cancel|Stroke)<br>Tool(Save|Restore)</td><td></td>
<tr><td>TranslateLayer</td><td>Translates (moves) the layer addressed (@ for current) by dx and dy. (The transformation is added to the current transformation matrix of the layer.)</td><td>TranslateLayer(@|last|idx, dx, dy)</td><td></td>
<tr><td><a href="action_details.html#unloadscript">UnloadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Unload a fungw script</td><td>UnloadScript(id)</td><td>script plugin</td>
<tr><td>ViewPortDialog</td><td>Bring up a viewport dialog copying the current design/zoom/pan of the main window. Optionally sets window title.</td><td>ViewPortDialog([title])</td><td>camv_dialogs</td>
<tr><td>VisLayer</td><td>Change the visibility of a layer addressed (@ for current). Not affected by ResetLayer().</td><td>VisLayer(@|last|idx, [0|1|toggle])</td><td></td>
<tr><td>Zoom</td><td>GUI zoom</td><td>Zoom()<br>Zoom([+|-|=]factor)<br>Zoom(x1, y1, x2, y2)<br>Zoom(?)<br>Zoom(get)<br>Zoom(auto_first)</td><td></td>
</table>
<p id="ringdove">RND: this action comes from librnd and is common to all ringdove applications.
</body>
</html>
